# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from range_msgs/P2PRange.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class P2PRange(genpy.Message):
  _md5sum = "7430dcef733fe13f19d650914fb243e4"
  _type = "range_msgs/P2PRange"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# Software License Agreement (BSD License)
#
# Copyright (C) 2014 - 2015 Robotics, Vision and Control Group, University of Seville.
#   2014 Felipe R.Fabresse <fabresse@us.es>
#   2015 Felipe R.Fabresse <felramfab@gmail.com>
#	2016 Fernando Caballero <fcaballero@us.es>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright notice, this
# list of conditions and the following disclaimer.
#
# * Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# This message represents a single range-only reading from a pair of devices 
# (emitter and receiver). 
# This message is  not appropriate for laser scanners or other non pair 
# to pair range sensor. See the LaserScan message if you are working with 
# a laser scanner and Range if you are working with non pair single active 
# ranger.

# In pair to pair range-only sensors the emitter sensor is the one which makes a 
# ranging request to another receiver device.

Header header

# Radiation type enumeration values
# If you want a value added to this list, send an email to felramfab@gmail.com
uint8 ULTRASOUND=0
uint8 RADIO=1

# Types of range devices (enumeration)
# If you want a value added to this list, send an email to felramfab@gmail.com
uint8 BASE=0 # Range sensor on-board a robot.
uint8 ANCHOR=1 # Range sensor (not BASE) which position is known.
uint8 TAG=2 # Range sensor (not BASE) which position is unknown (mainly used in 
               # range-only mapping applications).

# The type of radiation used by the sensor
uint8 radiation_type    # (ULTRASOUND, RADIO, etc) [enum]

# Source sensor ID (device that starts the ranging process)
uint64 source_id

# Type of the source range sensor
uint8 source_type      # (BASE, ANCHOR, TAG, etc) [enum]

# Destination sensor ID (device that communicates with the source and report the range value)
uint64 destination_id

# Type of the destination range sensor
uint8 destination_type      # (BASE, ANCHOR, TAG, etc) [enum]

# Received signal strength information (dBm)
float64 rssi

# Range measurement between emitter and receiver (meters)
float64 range

# Variance of range measurement.
float64 variance        # 0 is interpreted as variance unknown

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id
"""
  # Pseudo-constants
  ULTRASOUND = 0
  RADIO = 1
  BASE = 0
  ANCHOR = 1
  TAG = 2

  __slots__ = ['header','radiation_type','source_id','source_type','destination_id','destination_type','rssi','range','variance']
  _slot_types = ['std_msgs/Header','uint8','uint64','uint8','uint64','uint8','float64','float64','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,radiation_type,source_id,source_type,destination_id,destination_type,rssi,range,variance

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(P2PRange, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.radiation_type is None:
        self.radiation_type = 0
      if self.source_id is None:
        self.source_id = 0
      if self.source_type is None:
        self.source_type = 0
      if self.destination_id is None:
        self.destination_id = 0
      if self.destination_type is None:
        self.destination_type = 0
      if self.rssi is None:
        self.rssi = 0.
      if self.range is None:
        self.range = 0.
      if self.variance is None:
        self.variance = 0.
    else:
      self.header = std_msgs.msg.Header()
      self.radiation_type = 0
      self.source_id = 0
      self.source_type = 0
      self.destination_id = 0
      self.destination_type = 0
      self.rssi = 0.
      self.range = 0.
      self.variance = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_BQBQB3d.pack(_x.radiation_type, _x.source_id, _x.source_type, _x.destination_id, _x.destination_type, _x.rssi, _x.range, _x.variance))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 43
      (_x.radiation_type, _x.source_id, _x.source_type, _x.destination_id, _x.destination_type, _x.rssi, _x.range, _x.variance,) = _struct_BQBQB3d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_BQBQB3d.pack(_x.radiation_type, _x.source_id, _x.source_type, _x.destination_id, _x.destination_type, _x.rssi, _x.range, _x.variance))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 43
      (_x.radiation_type, _x.source_id, _x.source_type, _x.destination_id, _x.destination_type, _x.rssi, _x.range, _x.variance,) = _struct_BQBQB3d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_BQBQB3d = struct.Struct("<BQBQB3d")
_struct_3I = struct.Struct("<3I")
